// ~~ Generated by Modular Boilerplate ~~
import json from '@rollup/plugin-json';
// eslint-disable-next-line import/namespace
import { nodeResolve } from '@rollup/plugin-node-resolve';
import replace from '@rollup/plugin-replace';
import commonJs from '@rollup/plugin-commonjs';
import css from 'rollup-plugin-import-css';
import scss from 'rollup-plugin-scss';
import alias from '@rollup/plugin-alias';
import nodePolyfills from 'rollup-plugin-node-polyfills';
import { swc } from 'rollup-plugin-swc3';
import config from './src/config.cjs';

const replacement = 'preact/compat';

export const sharedPlugins = [
  json(),
  nodeResolve({
    preferBuiltins: true,
  }),
  commonJs(),
  css(),
  scss({
    watch: 'src/styles',
    output: false,
    includePaths: ['../node_modules', 'node_modules'],
  }),
  nodePolyfills(),
  alias({
    entries: [
      { find: 'react', replacement },
      { find: 'react-dom', replacement },
    ],
  }),
  replace({
    'preventAssignment': true,
    '__MFE_URL__': config.get('mfeUrl'),
    'process.env.NODE_ENV': '"production"',
  }),
  swc({
    include: /\.[mc]?[jt]sx?$/,
    exclude: /node_modules/,
    tsconfig: 'tsconfig.app.json',
    minify: config.get('isProdBuild'),

    jsc: {
      experimental: {
        plugins: [
          ['@lingui/swc-plugin', {}],
        ],
      },
      minify: config.get('isProdBuild') ? {
        format: {
          comments: false,
        },
      } : {},
    },
  }),
];
